apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "littleworld.fullname" . }}-frontend
  labels:
    {{- include "littleworld.labels" . | nindent 4 }}-frontend
spec:
  {{- if not .Values.frontend.autoscaling.enabled }}
  replicas: {{ .Values.frontend.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "littleworld.selectorLabels" . | nindent 6 }}-frontend
  template:
    metadata:
      annotations:
        littleworld/commit_short_sha: "{{ .Values.frontend.version.commit_short_sha }}"
        app.gitlab.com/app: {{ .Values.frontend.gitlab.app }}
        app.gitlab.com/env: {{ .Values.frontend.gitlab.env }}
      {{- with .Values.frontend.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "littleworld.selectorLabels" . | nindent 8 }}-frontend
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "littleworld.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}-frontend
          env:
          - name: LITTLEWORLD_BACKEND_SERVICE_NAME
            value: {{ include "littleworld.name" . }}-backend
          - name: LITTLEWORLD_BACKEND_SERVICE_PORT
            value: "{{ .Values.backend.service.port }}"
          - name: LITTLEWORLD_FRONTEND_PYTHON_PORT
            value: "{{ .Values.frontend.python.port }}"
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.frontend.image.repository }}:{{ .Values.frontend.image.tag | default "latest" }}"
          imagePullPolicy: {{ .Values.frontend.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.frontend.python.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /health
              port: http
          readinessProbe:
            httpGet:
              path: /health
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "littleworld.fullname" . }}-backend
  labels:
    {{- include "littleworld.labels" . | nindent 4 }}-backend
spec:
  {{- if not .Values.backend.autoscaling.enabled }}
  replicas: {{ .Values.backend.replicaCount }}
  {{- end }}
  selector:
    matchLabels:
      {{- include "littleworld.selectorLabels" . | nindent 6 }}-backend
  template:
    metadata:
      annotations:
        littleworld/commit_short_sha: "{{ .Values.backend.version.commit_short_sha }}"
        app.gitlab.com/app: {{ .Values.backend.gitlab.app }}
        app.gitlab.com/env: {{ .Values.backend.gitlab.env }}
      {{- with .Values.backend.podAnnotations }}
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "littleworld.selectorLabels" . | nindent 8 }}-backend
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      serviceAccountName: {{ include "littleworld.serviceAccountName" . }}
      securityContext:
        {{- toYaml .Values.podSecurityContext | nindent 8 }}
      containers:
        - name: {{ .Chart.Name }}-backend
          env:
          - name: LITTLEWORLD_BACKEND_SERVICE_NAME
            value: {{ include "littleworld.name" . }}-backend
          - name: LITTLEWORLD_BACKEND_SERVICE_PORT
            value: "{{ .Values.backend.service.port }}"
          - name: LITTLEWORLD_BACKEND_PYTHON_PORT
            value: "{{ .Values.backend.python.port }}"
          securityContext:
            {{- toYaml .Values.securityContext | nindent 12 }}
          image: "{{ .Values.backend.image.repository }}:{{ .Values.backend.image.tag | default "latest" }}"
          imagePullPolicy: {{ .Values.backend.image.pullPolicy }}
          ports:
            - name: http
              containerPort: {{ .Values.backend.python.port }}
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /health
              port: http
          readinessProbe:
            httpGet:
              path: /health
              port: http
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
---